﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DAL
{
    public class InformationFeedbackReport
    {
        /// <summary>
        /// 信息编号
        /// </summary>
        public string InformationId 
        { 
            get;
            set; 
        }

        /// <summary>
        /// 信息标题
        /// </summary>
        public string Title
        {
            get;
            set;
        }

        /// <summary>
        /// 信息发送时间
        /// </summary>
        public DateTime SendTime
        {
            get;
            set;
        }


        /// <summary>
        /// 发送信息会员数量
        /// </summary>
        public int ReceiveMemberAmount
        {
            get;
            set;
        }

        /// <summary>
        /// 反馈会员数量
        /// </summary>
        public int FeedbackMemberAmount
        {
            get;
            set;
        }

        private List<FeedbackTemlateMembers> _feedbackTemlateMembersList = new List<FeedbackTemlateMembers>();

        /// <summary>
        /// 反馈模板会员反馈信息集合
        /// </summary>
        public List<FeedbackTemlateMembers> FeedbackTemlateMembersList
        {
            get 
            { 
                return _feedbackTemlateMembersList;
            }
            set 
            { 
                _feedbackTemlateMembersList = value; 
            }
        }

        private List<FeedbackTemplateStatistics> _feedbackTemplateStatisticsList=new List<FeedbackTemplateStatistics>();

        /// <summary>
        /// 反馈模块会员反馈统计集合
        /// </summary>
        public List<FeedbackTemplateStatistics> FeedbackTemplateStatisticsList
        {
            get 
            { 
                return _feedbackTemplateStatisticsList; 
            }
            set 
            {
                _feedbackTemplateStatisticsList = value; 
            }
        }

    }

    /// <summary>
    /// 反馈模块会员反馈信息
    /// </summary>
    public class FeedbackTemlateMembers
    {
        /// <summary>
        /// 信息点评会员编号
        /// </summary>
        public string MemberId
        {
            get;
            set;
        }

        /// <summary>
        /// 信息点评会员名称
        /// </summary>
        public string MemberName
        {
            get;
            set;
        }

        /// <summary>
        /// 反馈内容
        /// </summary>
        public string FeedbackContent
        {
            get;
            set;
        }

        /// <summary>
        /// 反馈时间
        /// </summary>
        public DateTime CreateTime
        {
            get;
            set;
        }
    }

    /// <summary>
    /// 反馈模板会员反馈统计
    /// </summary>
    public class  FeedbackTemplateStatistics
    {
        /// <summary>
        /// 反馈模板编号
        /// </summary>
        public string FeedbackTemplateId
        {
            get;
            set;
        }

        /// <summary>
        /// 反馈模板内容
        /// </summary>
        public string FeedbackTemplateName
        {
            get;
            set;
        }

        /// <summary>
        /// 反馈模板会员反馈数量
        /// </summary>
        public int FeedbackTemplateFeedbackAmount
        {
            get;
            set;
        }
    }
}
